<script setup lang="ts">
import { ref } from 'vue'

import { useSalaryStore } from '@/stores/Salary/salary'
import { useMonthOfUserStore } from '@/stores/Salary/monthOfUser'
import { useCheckInOutStore } from '@/stores/CheckInOut'
import { useUserStore } from '@/stores/user'

import type { Salary, SalUser } from '@/types/Salary/Salary'
import type { mou } from '@/types/Salary/Mou'

import CheckmarkDialogVue from '@/components/CheckmarkDialog.vue'

const salaryStore = useSalaryStore()
const monthOfUserStore = useMonthOfUserStore()
const checkInOutStore = useCheckInOutStore()
const userStore = useUserStore()

const paymentUserheaders = [
  {
    title: 'User ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Full Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Paid Date',
    key: 'paymentDate',
    value: 'paymentDate'
  },
  {
    title: 'Status',
    key: 'Status',
    value: 'Status'
  },
  {
    title: 'Operation',
    key: 'operation',
    value: 'operation'
  }
]

const Monthlypaymentheaders = [
  {
    title: 'Monthly Payment ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Pay Date (MM/DD/YYYY)',
    key: 'date',
    value: 'date'
  }
]
const dialogHeaders = [
  {
    title: 'Date',
    key: 'date',
    value: 'date'
  },
  {
    title: 'Time In',
    key: 'timeIn',
    value: 'timeIn'
  },
  {
    title: 'Time Out',
    key: 'timeOut',
    value: 'timeOut'
  },
  {
    title: 'Total Hour',
    key: 'totalHour',
    value: 'totalHour'
  }
]

const editedItem = ref<Salary>()

const dialog = ref(false)
const employeetoDialog = ref<SalUser | null>(null)

const send = (item: Salary) => (editedItem.value = item)
function sendUser(item: SalUser) {
  if (item.status == 'NOT PAID') {
    employeetoDialog.value = item
    dialog.value = true
    newDate()
    updateDialogtable()
  }
}

function close() {
  dialog.value = false
  resetAllMinute()
}

function pay() {
  if (employeetoDialog.value != null) {
    updateUser()
    resetAllMinute()
    dialog.value = false
    performAction()
  }
}
const CheckmarkDialog = ref(false)
function performAction() {
  // แสดง v-dialog ด้วยเลื่อนเปิดเป็นระยะเวลา 2 วินาที
  CheckmarkDialog.value = true
  setTimeout(() => {
    CheckmarkDialog.value = false
  }, 2000)
}

const newPaidDate = ref<string | null>()
function newDate() {
  newPaidDate.value = salaryStore.formatDateTime(new Date())
}

function updateUser() {
  if (newPaidDate.value && employeetoDialog.value != null && editedItem.value != null) {
    employeetoDialog.value.status = 'PAID'
    employeetoDialog.value.paymentDate = new Date(newPaidDate.value)
    salaryStore.salaries[editedItem.value.id].detail[employeetoDialog.value.id] =
      employeetoDialog.value
  }
}

const dialogTable = ref<mou[]>([])
function updateDialogtable() {
  dialogTable.value = monthOfUserStore.WHOTU(
    checkInOutStore.checkDates,
    editedItem.value,
    employeetoDialog.value
  )
}

const formatDate = (date: Date) => new Date(date).toLocaleDateString()
const salaryPerHour = ref<number>(100)

function resetAllMinute() {
  monthOfUserStore.allMins = 0
}

function calTime(item: number): string {
  return checkInOutStore.formatMinutesToHHMM(item)
}

function calSalary(): number {
  const caled = (monthOfUserStore.allMins / 60) * salaryPerHour.value
  return Number(caled.toFixed(2))
}
</script>

<template>
  <v-sheet>
    <v-row>
      <!-- First Table -->
      <v-col cols="4">
        <v-card variant="outlined" color="primary">
          <v-card-title>Monthly Salary Payment</v-card-title>
          <v-data-table
            :items="salaryStore.salaries"
            :headers="Monthlypaymentheaders"
            class="elevation-1 custom-table"
            fixed-header
            height="350px"
          >
            <template v-slot:item="props">
              <tr @click="send(props.item)">
                <td>{{ props.item.id }}</td>
                <td>{{ salaryStore.formatDate(props.item.date) }}</td>
              </tr>
            </template>
          </v-data-table>
        </v-card>
      </v-col>

      <!-- Second Table -->
      <v-col cols="8">
        <v-card variant="outlined" color="primary">
          <v-card-title>Employee's Salary Payment</v-card-title>
          <v-data-table
            :items="editedItem?.detail"
            :headers="paymentUserheaders"
            class="elevation-1 custom-table"
            fixed-header
            height="350px"
          >
            <template v-slot:item="props">
              <tr>
                <td>{{ props.item.id }}</td>
                <td>{{ props.item.name }}</td>
                <td>{{ salaryStore.formatDateTime(props.item.paymentDate) }}</td>
                <td>{{ props.item.status }}</td>
                <td><v-icon size="small" @click="sendUser(props.item)"> mdi-cash </v-icon></td>
              </tr>
            </template>
          </v-data-table>
        </v-card>
      </v-col>
    </v-row>
  </v-sheet>

  <!-- dialog payment -->
  <v-dialog v-model="dialog" max-width="600" max-height="800">
    <v-card class="ma-4 pa-4">
      <v-card-title>PAYMENT</v-card-title>
      <v-card-subtitle>รายละเอียด</v-card-subtitle>
      <v-card-text>
        <div v-if="employeetoDialog">ชื่อ {{ employeetoDialog.name }}</div>
        <div v-if="employeetoDialog">วันที่จ่าย {{ newPaidDate }}</div>
        <div>บริษัท ท่านเทพ Kore wado จำกัด</div>
      </v-card-text>
      <v-sheet>
        <v-col cols="12">
          <v-card variant="outlined" color="primary">
            <v-card-title>การเข้าทำงานของพนักงานในเดือนนี้</v-card-title>

            <v-data-table
              :items="dialogTable"
              :headers="dialogHeaders"
              class="elevation-1 custom-table"
              fixed-header
              height="300px"
            >
              <template v-slot:item="props">
                <tr>
                  <td>{{ formatDate(props.item.date) }}</td>
                  <td>{{ checkInOutStore.formatTime(props.item.timeIn) }}</td>
                  <td>{{ checkInOutStore.formatTime(props.item.timeOut) }}</td>
                  <td>{{ calTime(props.item.totalMin) }}</td>
                </tr>
              </template>
            </v-data-table>
          </v-card>

          <v-card-text>
            <v-row>
              <v-col cols="7" class="text-left">
                <div>
                  จำนวนชั่วโมงที่ทำงานทั้งหมด
                  {{ checkInOutStore.formatMinutesToHHMM(monthOfUserStore.allMins) }} ชั่วโมง
                </div>
                <div>เงินเดือนที่ได้ {{ calSalary() }} บาท</div>
              </v-col>
              <v-col cols="5" class="text-right">
                <div>ผู้จ่าย {{ userStore.currentUser?.fullName }}</div>
              </v-col>
            </v-row>
          </v-card-text>
        </v-col>
        <v-card-actions class="justify-end">
          <v-btn
            class="button"
            style="background-color: rgb(255, 255, 255); color: #000000"
            @click="close"
            >Close</v-btn
          >
          <v-btn
            class="button"
            style="background-color: rgb(0, 149, 255); color: #ffffff"
            @click="pay"
            >Pay</v-btn
          >
        </v-card-actions>
      </v-sheet>
    </v-card>
  </v-dialog>

  <!-- dialog success -->
  <CheckmarkDialogVue v-model="CheckmarkDialog"></CheckmarkDialogVue>
</template>

<style scoped>
.flex-grow-1 {
  flex-grow: 1;
}

.button {
  width: 75px;
  font-weight: bold;
  border: 2px solid rgb(0, 149, 255);
}

.title-blue {
  color: #2196f3; /* สีน้ำเงิน */
}

.title-blue {
  color: #2196f3; /* สีน้ำเงิน */
}
</style>
@/stores/Salary/salary
